--- Linux-PAM-1.1.8/modules/pam_env/pam_env.c.orig	2013-06-18 14:11:21.000000000 +0000
+++ Linux-PAM-1.1.8/modules/pam_env/pam_env.c	2019-01-05 09:30:50.366972746 +0000
@@ -211,7 +211,7 @@ _parse_env_file(pam_handle_t *pamh, int
 	/* skip leading white space */
 	key += strspn(key, " \n\t");
 
-	/* skip blanks lines and comments */
+	/* skip blanks lines and comment lines */
 	if (key[0] == '#')
 	    continue;
 
@@ -220,9 +220,9 @@ _parse_env_file(pam_handle_t *pamh, int
 	if (strncmp(key, "export ", (size_t) 7) == 0)
 	    key += 7;
 
-	/* now find the end of value */
+	/* now find the end of value (N.B. appended comments are not supported) */
 	mark = key;
-	while(mark[0] != '\n' && mark[0] != '#' && mark[0] != '\0')
+	while(mark[0] != '\n' && mark[0] != '\0')
 	    mark++;
 	if (mark[0] != '\0')
 	    mark[0] = '\0';
@@ -320,21 +320,6 @@ static int _assemble_line(FILE *f, char
 	    os = s;
 
 	    /*
-	     * we are only interested in characters before the first '#'
-	     * character
-	     */
-
-	    while (*s && *s != '#')
-		 ++s;
-	    if (*s == '#') {
-		 *s = '\0';
-		 used += strlen(os);
-		 break;                /* the line has been read */
-	    }
-
-	    s = os;
-
-	    /*
 	     * Check for backslash by scanning back from the end of
 	     * the entered line, the '\n' has been included since
 	     * normally a line is terminated with this
@@ -357,7 +342,7 @@ static int _assemble_line(FILE *f, char
 	    }
 
 	} else {
-	    /* Nothing in this line */
+	    /* Nothing in this line (that isn't a comment) */
 	    /* Don't move p         */
 	}
     }
